/*
   fmtcoma.h

   Copyright (C) 1996 Jim Howell
   The material in this document may be freely used by anyone
   for any purpose, private or commercial, so long as this
   copyright notice is included and all changes to anything in
   the document are listed.

   A class for adding commas to a number converted
   to a string.
*/


#if !defined (FMTCOMA_H)
#define FMTCOMA_H


class nBuf;


class formatComma {
public:
                     formatComma          (long                n);
                     formatComma          (unsigned long       n);
                     operator const char* () const;
   const char*       operator &           () const;
   friend ostream&   operator <<          (ostream&            ostr,
                                           const formatComma&  fc);
private:
   void              SetCommas            (nBuf&               nstr);
   enum              {buff_len =16};
   char              buff [buff_len];
   char*             pb;
   static char       sep [];
   static void       SetSeparator         ();
   };


//  All of these operators return a pointer to the format buffer.
inline formatComma::operator const char* () const
{  return pb;  }

inline const char* formatComma::operator & () const
{  return pb;  }

inline ostream& operator << (
   ostream&             ostr,
   const formatComma&   fc)
{
   ostr <<(const char*)fc;
   return ostr;
   }


#endif


